-- from Note# 116833.1: "Index of Examples of Basic Advanced Queuing Features"

--alter system set job_queue_processes=4;
--alter system set aq_tm_processes=5;

-- As sys, set up an AQ user in the database, and grants appropriate privileges:
grant aq_administrator_role to ssstest_user;
grant execute on sys.dbms_aqadm to ssstest_user;
grant execute on sys.dbms_aq    to ssstest_user;
exec dbms_aqadm.grant_system_privilege('ENQUEUE_ANY','ssstest_user',FALSE) 
exec dbms_aqadm.grant_system_privilege('DEQUEUE_ANY','ssstest_user',FALSE) 

grant execute on sys.dbms_aqadm to scott;
grant execute on sys.dbms_aq    to scott;
exec dbms_aqadm.grant_system_privilege('ENQUEUE_ANY','scott',FALSE) 
exec dbms_aqadm.grant_system_privilege('DEQUEUE_ANY','scott',FALSE) 

-- Set up the queue structures, and starts the created queue
conn ssstest_user/ssstest_user

create type ssstest_user.ot_message as object(
  	run_id		int,
	iteration_id	int,
	user_id		int,
	lock_datetime	timestamp
)
/

exec DBMS_AQADM.CREATE_QUEUE_TABLE (                            	-
        queue_table             => 'ssstest_user.ssstest_queue_table',  -
        queue_payload_type      => 'ssstest_user.ot_message',          	-
        compatible              => '8.1')

exec DBMS_AQADM.CREATE_QUEUE (                                  	-
        queue_name              => 'ssstest_user.ssstest_queue',      	-
        queue_table             => 'ssstest_user.ssstest_queue_table')

exec DBMS_AQADM.START_QUEUE ( queue_name => 'ssstest_user.ssstest_queue')

--
grant execute on ssstest_user.ot_message to scott;
grant select,insert,update,delete on ssstest_user.ssstest_queue_table to scott;

