-- Similar to a main runstats_pkg, but:
-- 1) doesn't take snapshot of resource consumption
-- 2) expects 2 tests: stateLESS first, followed by stateFULL

-- Modified Tom Kytes's test-harness to test 1) Elapsed time diff 2) Amount of resources required:
set serveroutput on def off

CREATE OR REPLACE PACKAGE ssstest_user.pkg_ssstest_runstats_state IS
  PROCEDURE prc_results(
	 p_distribution	CHAR		DEFAULT 'Z'
        ,p_rampup_users ot_varray_rampup_users
  );
END pkg_ssstest_runstats_state;
/

sho err


CREATE OR REPLACE PACKAGE BODY ssstest_user.pkg_ssstest_runstats_state IS
  PROCEDURE prc_results (
         p_distribution CHAR            DEFAULT 'Z'
        ,p_rampup_users ot_varray_rampup_users
  ) AS
	t_runs			INT;
	t_distro_string		VARCHAR2(50);
	t_elapsed_time_snap	VARCHAR2(2000);
	t_elapsed_time_ulast	VARCHAR2(2000);
	t_elapsed_time_flast	VARCHAR2(2000);
  BEGIN
	SELECT Count( Distinct run_id) INTO t_runs FROM ssstest_user.ssstest_runstats_messages WHERE run_id < 100;
	IF( t_runs = 2) THEN
		dbms_output.put_line( '*** Error: Not implemented in this version');
	ELSIF( t_runs = 3) THEN
		dbms_output.put_line( '*** Error: Not implemented in this version');
	ELSIF( t_runs = 4) THEN
		dbms_output.put_line( '*** Error: Not implemented in this version');
	ELSIF( t_runs = 5) THEN
			IF (p_distribution = 'D') THEN
				t_distro_string := 'Deterministic Distribution';
			ELSIF (p_distribution = 'Z') THEN
				t_distro_string := 'Zero (all-at-once) Distribution';
			ELSE
				t_distro_string := '???????????  Distribution';
			END IF;
			dbms_output.put_line( lpad( t_distro_string, 103));
			dbms_output.put_line( lpad( 'StateLESS', 70) || lpad( 'StateFULL', 55));
			dbms_output.put_line( lpad(' ', 31) || rpad( '-', 59, '-') || '|' || rpad( '-', 59, '-'));

			SELECT	Rpad( '... Elapsed Time: FUser [cs] c', 30) ||
				To_Char( Sum( Decode( run_id, 1, ela, 0)), '999,999,999') ||
				To_Char( Sum( Decode( run_id, 2, ela, 0)), '999,999,999') ||
				To_Char( Sum( Decode( run_id, 3, ela, 0)), '999,999,999') ||
				To_Char( Sum( Decode( run_id, 4, ela, 0)), '999,999,999') ||
				To_Char( Sum( Decode( run_id, 5, ela, 0)), '999,999,999') ||  '|' ||
				To_Char( Sum( Decode( run_id, 1001, ela, 0)),  '99,999,999') ||
				To_Char( Sum( Decode( run_id, 1002, ela, 0)), '999,999,999') ||
				To_Char( Sum( Decode( run_id, 1003, ela, 0)), '999,999,999') ||
				To_Char( Sum( Decode( run_id, 1004, ela, 0)), '999,999,999') ||
				To_Char( Sum( Decode( run_id, 1005, ela, 0)), '999,999,999') 
			INTO	t_elapsed_time_flast
			FROM	(
				SELECT
					 run_id
					,Min( ela) ela		--Decode( ela, 0, NULL, ela)) ela
				FROM	(
                                	SELECT
						 (CASE WHEN run_id < 1000  
						       THEN (CASE WHEN run_id-100 < 0 THEN run_id ELSE run_id-100 END )
                      				       ELSE (CASE WHEN run_id-1100 < 0 THEN run_id ELSE run_id-100 END )
                				  END
                				 ) run_id
                                                ,( (To_Char( end_time, 'SSSSS') + To_Char( end_time, 'FF2')/100)
						 - 
						      (To_Char( create_datetime, 'SSSSS') + To_Char( create_datetime, 'FF2')/100)
						)*100 ela
                                        FROM    (
                                        	SELECT
                                                	 run_id
                                                        ,user_id
                                                        ,create_datetime
							,(CASE WHEN run_id < 1000 -- meaning it's stateLESS
                              				      THEN ( Max(create_datetime) OVER (PARTITION BY (
									CASE WHEN run_id-100 < 0 
									     THEN run_id ELSE run_id-100 END ), user_id
								      ) 
								   )
                              				      ELSE ( Max(create_datetime) OVER (PARTITION BY (
									CASE WHEN run_id-1100 < 0
									     THEN run_id ELSE run_id-100 END ), user_id
								     ) 
								  )
                        				 END
                        				) end_time
                                                FROM    ssstest_user.ssstest_runstats_messages
                                                )
					)
					WHERE ela != 0
                                GROUP BY run_id
				);
			dbms_output.put_line( t_elapsed_time_flast);

			SELECT	Rpad( '... Elapsed Time: LUser [cs] c', 30) ||
				To_Char( Sum( Decode( run_id, 1, ela, 0)), '999,999,999') ||
				To_Char( Sum( Decode( run_id, 2, ela, 0)), '999,999,999') ||
				To_Char( Sum( Decode( run_id, 3, ela, 0)), '999,999,999') ||
				To_Char( Sum( Decode( run_id, 4, ela, 0)), '999,999,999') ||
				To_Char( Sum( Decode( run_id, 5, ela, 0)), '999,999,999') ||  '|' ||
				To_Char( Sum( Decode( run_id, 1001, ela, 0)),  '99,999,999') ||
				To_Char( Sum( Decode( run_id, 1002, ela, 0)), '999,999,999') ||
				To_Char( Sum( Decode( run_id, 1003, ela, 0)), '999,999,999') ||
				To_Char( Sum( Decode( run_id, 1004, ela, 0)), '999,999,999') ||
				To_Char( Sum( Decode( run_id, 1005, ela, 0)), '999,999,999') 
			INTO	t_elapsed_time_ulast
			FROM	(
                                	SELECT
						 (CASE WHEN run_id < 1000  
						       THEN (CASE WHEN run_id-100 < 0 THEN run_id ELSE run_id-100 END )
                      				       ELSE (CASE WHEN run_id-1100 < 0 THEN run_id ELSE run_id-100 END )
                				  END
                				 ) run_id
                                                ,Max( (To_Char( end_time, 'SSSSS') + To_Char( end_time, 'FF2')/100)
						 - 
						      (To_Char( create_datetime, 'SSSSS') + To_Char( create_datetime, 'FF2')/100)
						)*100 ela
                                        FROM    (
                                        	SELECT
                                                	 run_id
                                                        ,user_id
                                                        ,create_datetime
							,(CASE WHEN run_id < 1000 -- meaning it's stateLESS
                              				      THEN ( Max(create_datetime) OVER (PARTITION BY (
									CASE WHEN run_id-100 < 0 
									     THEN run_id ELSE run_id-100 END ), user_id
								      ) 
								   )
                              				      ELSE ( Max(create_datetime) OVER (PARTITION BY (
									CASE WHEN run_id-1100 < 0
									     THEN run_id ELSE run_id-100 END ), user_id
								     ) 
								  )
                        				 END
                        				) end_time
                                                FROM    ssstest_user.ssstest_runstats_messages
                                                )
                                        GROUP BY 
                				 (CASE WHEN run_id < 1000 -- meaning it's stateLESS
                      				      THEN (CASE WHEN run_id-100 < 0 THEN run_id ELSE run_id-100 END )
                      				      ELSE (CASE WHEN run_id-1100 < 0 THEN run_id ELSE run_id-100 END )
                				 END
						 )
				);
			dbms_output.put_line( t_elapsed_time_ulast);

		dbms_output.put_line( rpad('-', 30, '-') || ' ' ||
			rpad('-', 11, '-') || ' ' ||
			rpad('-', 11, '-') || ' ' ||
			rpad('-', 11, '-') || ' ' ||
			rpad('-', 11, '-') || ' ' ||
			rpad('-', 11, '-') || '|' || -- end of 5 runs
			rpad('-', 11, '-') || ' ' ||
			rpad('-', 11, '-') || ' ' ||
			rpad('-', 11, '-') || ' ' ||
			rpad('-', 11, '-') || ' ' ||
			rpad('-', 11, '-') );
                dbms_output.put_line
                    ( rpad( 'Resources (stat/latch) & Ela', 30 ) || 
                      lpad( 'Run1', 6 ) || ' - ' || lpad( p_rampup_users(1), 3, '0') ||
                      lpad( 'Run2', 6 ) || ' - ' || lpad( p_rampup_users(2), 3, '0') ||
                      lpad( 'Run3', 6 ) || ' - ' || lpad( p_rampup_users(3), 3, '0') ||
                      lpad( 'Run4', 6 ) || ' - ' || lpad( p_rampup_users(4), 3, '0') ||
                      lpad( 'Run5', 6 ) || ' - ' || lpad( p_rampup_users(5), 3, '0') || '|' ||
                      lpad( 'Run1', 5 ) || ' - ' || lpad( p_rampup_users(6), 3, '0') ||
                      lpad( 'Run2', 6 ) || ' - ' || lpad( p_rampup_users(7), 3, '0') ||
                      lpad( 'Run3', 6 ) || ' - ' || lpad( p_rampup_users(8), 3, '0') ||
                      lpad( 'Run4', 6 ) || ' - ' || lpad( p_rampup_users(9), 3, '0') ||
                      lpad( 'Run5', 6 ) || ' - ' || lpad( p_rampup_users(10),3, '0')  );
	ELSE
		dbms_output.put_line('*** Error: Only 2, 3, 4 or 5 runs are allowed. Received number of runs=' || t_runs);
	END IF;
  END prc_results;
END pkg_ssstest_runstats_state;
/

sho err

CREATE or replace PUBLIC SYNONYM pkg_ssstest_runstats_state FOR ssstest_user.pkg_ssstest_runstats_state;
GRANT EXECUTE ON pkg_ssstest_runstats_state TO scott;

set def on
